{
Copyright  1998 by Delphi 4 Developer's Guide - Xavier Pacheco and Steve Teixeira
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, NavStatFrm;

type
  TMainForm = class(TForm)
    pnlMain: TPanel;
    Splitter1: TSplitter;
    pnlParent: TPanel;
    btnNormal: TButton;
    btnAsChild: TButton;
    btnFreeChild: TButton;
    mmMainMenu: TMainMenu;
    mmiFile: TMenuItem;
    procedure btnNormalClick(Sender: TObject);
    procedure btnAsChildClick(Sender: TObject);
    procedure btnFreeChildClick(Sender: TObject);
  private
    FNavStatForm: TNavStatForm;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.btnNormalClick(Sender: TObject);
var
  LocalNavStatForm: TNavStatForm;
begin
  LocalNavStatForm := TNavStatForm.Create(Application);
  try
    LocalNavStatForm.ShowModal;
  finally
    LocalNavStatForm.Free;
  end;
end;

procedure TMainForm.btnAsChildClick(Sender: TObject);
begin
  if not Assigned(FNavStatForm) then
  begin
    FNavStatForm := TNavStatForm.Create(Application, pnlParent);
    FNavStatForm.SetToolBarParent(self);
    FNavStatForm.SetStatusBarParent(self);
    mmMainMenu.Merge(FNavStatForm.mmFormMenu);
    FNavStatForm.Show;
    pnlParent.Height := pnlParent.Height - 1;
  end;
end;

procedure TMainForm.btnFreeChildClick(Sender: TObject);
begin
  if Assigned(FNavStatForm) then
  begin
    mmMainMenu.UnMerge(FNavStatForm.mmFormMenu);
    FNavStatForm.Free;
    FNavStatForm := nil;
  end;
end;

end.
