{
Copyright  1998 by Delphi 4 Developer's Guide - Xavier Pacheco and Steve Teixeira
}

unit ModelessFrm;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TModeless = class(TForm)
    btnCancel: TBitBtn;
    btnOK: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Modeless: TModeless;

implementation

{$R *.DFM}

procedure TModeless.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;  // Free the form instance when closed
end;

procedure TModeless.FormDestroy(Sender: TObject);
begin
  Modeless := nil; // Set the NonModalForm variable to nil when destroyed.
end;

procedure TModeless.btnCancelClick(Sender: TObject);
begin
  ShowMessage('Cancel Pressed');
end;

procedure TModeless.btnOKClick(Sender: TObject);
begin
  ShowMessage('Ok Pressed');
end;

end.
