{
Copyright  1998 by Delphi 4 Developer's Guide - Xavier Pacheco and Steve Teixeira
}

unit MainFrm;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls;

type
  TMainForm = class(TForm)
    mmMain: TMainMenu;
    mmiBrushes: TMenuItem;
    mmiPatterns: TMenuItem;
    mmiBitmapPattern1: TMenuItem;
    mmiBitmapPattern2: TMenuItem;
    procedure mmiPatternsClick(Sender: TObject);
    procedure mmiBitmapPattern1Click(Sender: TObject);
    procedure mmiBitmapPattern2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FBitmap: TBitmap;
  public
    procedure ClearCanvas;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.ClearCanvas;
var
  R: TRect;
begin
 // Clear the contents of the canvas
  with Canvas do
  begin
    Brush.Style := bsSolid;
    Brush.Color := clWhite;
    GetWindowRect(Handle, R);
    R.TopLeft := ScreenToClient(R.TopLeft);
    R.BottomRight := ScreenToClient(R.BottomRight);
    FillRect(R);
  end;
end;

procedure TMainForm.mmiPatternsClick(Sender: TObject);
begin
  ClearCanvas;
  with Canvas do
  begin
    // Write out titles for the various brush styles
    TextOut(120, 101, 'bsSolid');
    TextOut(10, 101, 'bsClear');
    TextOut(240, 101, 'bsCross');
    TextOut(10, 221, 'bsBDiagonal');
    TextOut(120, 221, 'bsFDiagonal');
    TextOut(240, 221, 'bsDiagCross');
    TextOut(10, 341, 'bsHorizontal');
    TextOut(120, 341, 'bsVertical');

    // Draw a rectangle with the various brush styles

    Brush.Style := bsClear;
    Rectangle(10, 10, 100, 100);
    Brush.Color := clBlack;

    Brush.Style := bsSolid;
    Rectangle(120, 10, 220, 100);

    { Demonostate that the brush is transparent by drawing
      colored rectangle, over which the brush style rectangle will
      be drawn. }

    Brush.Style := bsSolid;
    Brush.Color := clRed;
    Rectangle(230, 0, 330, 90);

    Brush.Style := bsCross;
    Brush.Color := clBlack;
    Rectangle(240, 10, 340, 100);

    Brush.Style := bsBDiagonal;
    Rectangle(10, 120, 100, 220);

    Brush.Style := bsFDiagonal;
    Rectangle(120, 120, 220, 220);

    Brush.Style := bsDiagCross;
    Rectangle(240, 120, 340, 220);

    Brush.Style := bsHorizontal;
    Rectangle(10, 240, 100, 340);

    Brush.Style := bsVertical;
    Rectangle(120, 240, 220, 340);

  end;
end;

procedure TMainForm.mmiBitmapPattern1Click(Sender: TObject);
begin
  ClearCanvas;
  // Load a bitmap from the disk
  FBitMap.LoadFromFile('pattern.bmp');
  Canvas.Brush.Bitmap := FBitmap;
  try
    { Draw a rectangle to cover the form's entire
      client area using the bitmap pattern as the
      brush with which to paint. }
    Canvas.Rectangle(0, 0, ClientWidth, ClientHeight);
  finally
    Canvas.Brush.Bitmap := nil;
  end;
end;

procedure TMainForm.mmiBitmapPattern2Click(Sender: TObject);
begin
  ClearCanvas;
  // Load a bitmap from the disk
  FBitMap.LoadFromFile('pattern2.bmp');
  Canvas.Brush.Bitmap := FBitmap;
  try
    { Draw a rectangle to cover the form's entire
      client area using the bitmap pattern as the
      brush with which to paint. }
    Canvas.Rectangle(0, 0, ClientWidth, ClientHeight);
  finally
    Canvas.Brush.Bitmap := nil;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FBitmap := TBitmap.Create;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FBitmap.Free;
end;

end.



