{
Copyright  1998 by Delphi 4 Developer's Guide - Xavier Pacheco and Steve Teixeira
}

unit MainFrm;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, ExtCtrls;

type
  TMainForm = class(TForm)
    mmMain: TMainMenu;
    mmiPens: TMenuItem;
    mmiStyles: TMenuItem;
    mmiPenColors: TMenuItem;
    mmiPenMode: TMenuItem;
    procedure mmiStylesClick(Sender: TObject);
    procedure mmiPenColorsClick(Sender: TObject);
    procedure mmiPenModeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ClearCanvas;
    procedure SetPenDefaults;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.ClearCanvas;
var
  R: TRect;
begin
 // Clear the contents of the canvas
  with Canvas do
  begin
    Brush.Style := bsSolid;
    Brush.Color := clWhite;
    GetWindowRect(Handle, R);
    R.TopLeft := ScreenToClient(R.TopLeft);
    R.BottomRight := ScreenToClient(R.BottomRight);
    FillRect(R);
  end;
end;

procedure TMainForm.SetPenDefaults;
begin
  with Canvas.Pen do
  begin
    Width := 1;
    Mode := pmCopy;
    Style := psSolid;
    Color := clBlack;
  end;
end;

procedure TMainForm.mmiStylesClick(Sender: TObject);
var
  yPos: integer;
  PenStyle: TPenStyle;
begin
  ClearCanvas;     // First clear Canvas's contents
  SetPenDefaults;
  // yPos represent the Y coordinate
  YPos := 20;
  with Canvas do
  begin
    for PenStyle := psSolid to psInsideFrame do
    begin
      Pen.Color := clBlue;
      Pen.Style := PenStyle;
      MoveTo(100, yPos);
      LineTo(ClientWidth, yPos);
      inc(yPos, 20);
    end;

    // Write out titles for the various pen styles
    TextOut(1, 10, ' psSolid ');
    TextOut(1, 30, ' psDash ');
    TextOut(1, 50, ' psDot ');
    TextOut(1, 70, ' psDashDot ');
    TextOut(1, 90, ' psDashDotDot ');
    TextOut(1, 110, ' psClear ');
    TextOut(1, 130, ' psInsideFrame ');
  end;
end;

procedure TMainForm.mmiPenColorsClick(Sender: TObject);
var
  i: integer;
begin
  ClearCanvas;    // Clear Canvas's contents
  SetPenDefaults;
  with Canvas do
  begin
    for i := 1 to 100 do
    begin
      // Get a random pen color draw a line using that color
      Pen.Color := RGB(Random(255),Random(255), Random(255));
      MoveTo(random(ClientWidth), Random(ClientHeight));
      LineTo(random(ClientWidth), Random(ClientHeight));
    end
  end;
end;

procedure TMainForm.mmiPenModeClick(Sender: TObject);
var
  x,y: integer;
begin
  ClearCanvas;  // Clear the Canvas's contents
  SetPenDefaults;
  y := 10;
  canvas.Pen.Width := 20;
  while y < ClientHeight do
  begin
    canvas.MoveTo(0, y);
    // Draw a line and increment Y value
    canvas.LineTo(ClientWidth, y);
    inc(y, 30);
  end;
  x := 5;

  canvas.pen.Mode := pmNot;
  while x < ClientWidth do
  begin
    Canvas.MoveTo(x, 0);
    canvas.LineTo(x, ClientHeight);
    inc(x, 30);
  end;
end;

end.
