unit PriU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls;

type
  TThreadPriWin = class(TForm)
    PriTrackBar: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    OKBtn: TBitBtn;
    RevertBtn: TBitBtn;
    Panel1: TPanel;
    procedure PriTrackBarChange(Sender: TObject);
    procedure RevertBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    OldPriVal: Integer;
  public
    { Public declarations }
  end;

var
  ThreadPriWin: TThreadPriWin;

implementation

{$R *.DFM}

uses Main, SrchU;

procedure TThreadPriWin.PriTrackBarChange(Sender: TObject);
begin
  with MainForm do begin
    SearchPri := PriTrackBar.Position;
    if Running then
      SearchThread.Priority := TThreadPriority(PriTrackBar.Position);
  end;
end;

procedure TThreadPriWin.RevertBtnClick(Sender: TObject);
begin
  PriTrackbar.Position := OldPriVal;
end;

procedure TThreadPriWin.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caHide;
end;

procedure TThreadPriWin.FormShow(Sender: TObject);
begin
  OldPriVal := PriTrackBar.Position;
end;

procedure TThreadPriWin.OKBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TThreadPriWin.FormCreate(Sender: TObject);
begin
  PriTrackBarChange(Sender);        // initialize thread priority
end;

end.
