unit AddModU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TAddModAction = (amaAdd, amaModify);

  TAddModForm = class(TForm)
    OkBtn: TButton;
    CancelBtn: TButton;
    OpenDialog: TOpenDialog;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    PathEd: TEdit;
    NameEd: TEdit;
    BrowseBtn: TButton;
    procedure BrowseBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function AddModExpert(AAction: TAddModAction; var ExpName, ExpPath: String): Boolean;

implementation

{$R *.DFM}

function AddModExpert(AAction: TAddModAction; var ExpName, ExpPath: String): Boolean;
{ called to invoke dialog to add and modify registry entries }
const
  CaptionArray: array[TAddModAction] of string[31] =
    ('Add new expert', 'Modify expert');
begin
  with TAddModForm.Create(Application) do       // create dialog
  begin
    Caption := CaptionArray[AAction];            // set caption
    if AAction = amaModify then                  // if modify...
    begin
      NameEd.Text := ExpName;                   // init name and
      PathEd.Text := ExpPath;                   // path
    end;
    Result := ShowModal = mrOk;                 // show dialog
    if Result then                              // if Ok...
    begin
      ExpName := NameEd.Text;                   // set name and
      ExpPath := PathEd.Text;                   // path
    end;
    Free;
  end;
end;

procedure TAddModForm.BrowseBtnClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    PathEd.Text := OpenDialog.FileName;
end;


end.
