unit Rng;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TRangeForm = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    StartEdit: TEdit;
    Label1: TLabel;
    EndEdit: TEdit;
    Label7: TLabel;
    ApplyButton: TButton;
    CancelButton: TButton;
    procedure ApplyButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure ToggleRangeButtons;
  public
    { Public declarations }
  end;

var
  RangeForm: TRangeForm;

implementation

uses DataMod, Main;

{$R *.DFM}

procedure TRangeForm.ApplyButtonClick(Sender: TObject);
begin
  { Set range of records in dataset from StartEdit's value to EndEdit's }
  { value.  Strings are again implicitly converted to numerics.         }
  DM.Table1.SetRange([StartEdit.Text], [EndEdit.Text]);
  ToggleRangeButtons;                 // enable proper buttons
end;

procedure TRangeForm.CancelButtonClick(Sender: TObject);
begin
  DM.Table1.CancelRange;                 // remove set range
  ToggleRangeButtons;                 // enable proper buttons
end;

procedure TRangeForm.ToggleRangeButtons;
begin
  { Toggle the enabled property of the range buttons }
  ApplyButton.Enabled := not ApplyButton.Enabled;
  CancelButton.Enabled := not CancelButton.Enabled;
end;

procedure TRangeForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caHide;
  MainForm.Range1.Checked := False;
end;

end.
