{
Copyright  1998 by Delphi 4 Developer's Guide - Xavier Pacheco and Steve Teixeira
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, BDE, Db, DBTables;

type
  TMainForm = class(TForm)
    dbMain: TDatabase;
    tblEmployee: TTable;
    dsEmployee: TDataSource;
    dgbEmployee: TDBGrid;
    btnLogon: TButton;
    btnLogOff: TButton;
    procedure btnLogonClick(Sender: TObject);
    procedure dbMainLogin(Database: TDatabase; LoginParams: TStrings);
    procedure btnLogOffClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  public
    TempLoginParams: TStringList;
    LoginSuccess: Boolean;
  end;

var
  MainForm: TMainForm;

implementation
uses LoginFrm;

{$R *.DFM}

procedure TMainForm.btnLogonClick(Sender: TObject);
begin
  // Get the new login params.
  if GetLoginParams(TempLoginParams) = mrOk then
  begin
    // Disconnect the TDatabase component
    dbMain.Connected := False;
    try
      { Attempt to reconnect the TDatabase component. This will invoke
        the DataBase1Login event handler which will set the LoginParams
        with the current user name and password. }
      dbMain.Connected := True;
      tblEmployee.Active := True;
      LoginSuccess := True;
    except
      on EDBEngineError do
      begin
        //If login failed, specify a failed login and re-raise the exception
        LoginSuccess := False;
        Raise;
      end;
    end;
  end;
end;

procedure TMainForm.dbMainLogin(Database: TDatabase;
  LoginParams: TStrings);
begin
  LoginParams.Assign(TempLoginParams);
end;

procedure TMainForm.btnLogOffClick(Sender: TObject);
begin
  { Disconnect the TDatabase component and set the UserName
    and password variables to empty strings }
  dbMain.Connected := False;
  TempLoginParams.Clear;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  TempLoginParams := TStringList.Create;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  TempLoginParams.Free;
end;

end.
