unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp, Graphics;

type
  TWebModule1 = class(TWebModule)
    procedure WebModule1Create(Sender: TObject);
    procedure WebModule1WebActionItem1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1WebActionItem2Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1WebActionItem3Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    
    procedure WebModule1WebActionItem4Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
    JPEGFilename: String;
  public
    { Public declarations }
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.DFM}
{$R STREAM.RES}

uses JPEG;

procedure TWebModule1.WebModule1Create(Sender: TObject);
var
  Path: array[0..MAX_PATH - 1] of Char;
  PathStr: string;
begin
  SetString(PathStr, Path, GetModuleFileName(HInstance, Path, SizeOf(Path)));
  JPEGFilename := ExtractFilePath(PathStr) + 'TESTIMG.JPG';
end;

procedure TWebModule1.WebModule1WebActionItem1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  RS: TResourceStream;
begin
    RS := TResourceStream.Create(hInstance, 'BARK', RT_RCDATA);
    try
      Response.ContentType := 'audio/x-wav';
      Response.SendStream(RS);
      Handled := True;
    finally
      RS.Free;
    end;
end;

procedure TWebModule1.WebModule1WebActionItem2Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  FS: TFileStream;
begin
    FS := TFileStream.Create(JPEGFilename, fmOpenRead);
    try
      Response.ContentType := 'image/jpeg';
      Response.ContentStream := FS;
      Response.SendResponse;
      Handled := True;
    finally
      FS.Free;
    end;
end;

procedure TWebModule1.WebModule1WebActionItem3Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  BM: TBitmap;
  JPEGImage: TJPEGImage;
begin
    BM := TBitmap.Create;
    JPEGImage := TJPEGImage.Create;
    try
      BM.Handle := LoadBitmap(hInstance, 'ATHENA');
      JPEGImage.Assign(BM);
      Response.ContentStream := TMemoryStream.Create;
      JPEGImage.SaveToStream(Response.ContentStream);
      Response.ContentStream.Position := 0;
      Response.SendResponse;
      Handled := True;
    finally
      BM.Free;
      JPEGImage.Free;
    end;
end;

procedure TWebModule1.WebModule1WebActionItem4Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
  Response.ContentStream := TResourceStream.Create(hInstance, 'JPEG', RT_RCDATA);
  Response.ContentType := 'image/jpeg';
  Response.SendResponse;
  Handled := True;
end;

end.
