unit CustomerFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBNavStatFrm, StdCtrls, DBCtrls, Mask, Menus, ImgList, ComCtrls, ToolWin,
  Db, DBModeFrm;

type
  TCustomerForm = class(TDBNavStatForm)
    lblFirstName: TLabel;
    dbeFirstName: TDBEdit;
    lblLastName: TLabel;
    dbeLastName: TDBEdit;
    lblCreditLine: TLabel;
    dbeCreditLine: TDBEdit;
    lblWorkAddress: TLabel;
    dbeWorkAddress: TDBEdit;
    lblHomeAddress: TLabel;
    dbeHomeAddress: TDBEdit;
    lblCity: TLabel;
    dbeCity: TDBEdit;
    lblState: TLabel;
    dbeState: TDBEdit;
    lblZipCode: TLabel;
    dbeZip: TDBEdit;
    lblWorkPhone: TLabel;
    dbeWorkPhone: TDBEdit;
    lblHomePhone: TLabel;
    dbeHomePhone: TDBEdit;
    lblComments: TLabel;
    dbmmComments: TDBMemo;
    lblCompany: TLabel;
    dbeCompany: TDBEdit;
    dsCustomer: TDataSource;
    EXit1: TMenuItem;
    procedure sbFirstClick(Sender: TObject);
    procedure sbPrevClick(Sender: TObject);
    procedure sbNextClick(Sender: TObject);
    procedure sbLastClick(Sender: TObject);
    procedure sbInsertClick(Sender: TObject);
    procedure sbEditClick(Sender: TObject);
    procedure sbDeleteClick(Sender: TObject);
    procedure sbCancelClick(Sender: TObject);
    procedure sbAcceptClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sbFindClick(Sender: TObject);
    procedure sbBrowseClick(Sender: TObject);
  private
    procedure SetNavButtons;
  public
    function GetFormMenu: TMainMenu; override;
    function CanChange: Boolean; override;
  end;

var
  CustomerForm: TCustomerForm;

implementation

uses SalesDM;

{$R *.DFM}

procedure TCustomerForm.SetNavButtons;
begin
  // Ensure that the navigational buttons are set according to the form's mode.
  sbFirst.Enabled := not DDGSalesDataModule.IsFirstCustomer;
  sbLast.Enabled  := not DDGSalesDataModule.IsLastCustomer;
  sbPrev.Enabled  := not DDGSalesDataModule.IsFirstCustomer;
  sbNext.Enabled  := not DDGSalesDataModule.IsLastCustomer;

  // synchronize the navigational menu items with the speedbuttons.
  mmiFirst.Enabled    := sbFirst.Enabled;
  mmiLast.Enabled     := sbLast.Enabled;
  mmiPrevious.Enabled := sbPrev.Enabled;
  mmiNext.Enabled     := sbNext.Enabled;
end;

procedure TCustomerForm.sbFirstClick(Sender: TObject);
begin
  // Go to the first record in the result set. 
  inherited;
  DDGSalesDataModule.FirstCustomer;
  SetNavButtons;
end;

procedure TCustomerForm.sbPrevClick(Sender: TObject);
begin
  // Go to the previous record in the result set.
  inherited;
  DDGSalesDataModule.PrevCustomer;
  SetNavButtons;
end;

procedure TCustomerForm.sbNextClick(Sender: TObject);
begin
  // Go to the next record in the result set.
  inherited;
  DDGSalesDataModule.NextCustomer;
  SetNavButtons;
end;

procedure TCustomerForm.sbLastClick(Sender: TObject);
begin
  // Go to the last record in the result set. 
  inherited;
  DDGSalesDataModule.LastCustomer;
  SetNavButtons;
end;

procedure TCustomerForm.sbInsertClick(Sender: TObject);
begin
  // Insert a new customer. 
  inherited;
  DDGSalesDataModule.NewCustomer;
end;

procedure TCustomerForm.sbEditClick(Sender: TObject);
begin
  // Edit the current customer. 
  inherited;
  DDGSalesDataModule.EditCustomer;
end;

procedure TCustomerForm.sbDeleteClick(Sender: TObject);
begin
  // Delete the current customer.
  inherited;
  DDGSalesDataModule.DeleteCustomer;
end;

procedure TCustomerForm.sbCancelClick(Sender: TObject);
begin
  // Cancel the Edit or Add operation. 
  inherited;
  DDGSalesDataModule.CancelCustomer;
end;

procedure TCustomerForm.sbAcceptClick(Sender: TObject);
begin
  // Accept Add or Edit changes.
  inherited;
  DDGSalesDataModule.AcceptCustomer;
end;

procedure TCustomerForm.FormShow(Sender: TObject);
begin
  // Initialize menus and buttons accordingly. 
  inherited;
  SetNavButtons;
end;

function TCustomerForm.CanChange: Boolean;
begin
  // Allow the user to change forms only when browing record. 
  Result := FormMode = fmBrowse;
end;

function TCustomerForm.GetFormMenu: TMainMenu;
begin
  { Return the main menu. This is required by the main form for
    menu merging. }
  Result := mmFormMenu;
end;

procedure TCustomerForm.sbFindClick(Sender: TObject);
begin
  // Search for a specific customer by invoking the customer search form. 
  inherited;
  DDGSalesDataModule.SearchForCustomer;
end;

procedure TCustomerForm.sbBrowseClick(Sender: TObject);
begin
  // Set the form to browse mode. This will cancel an edit or add operation. 
  inherited;
  if not (FormMode = fmBrowse) then
    DDGSalesDataModule.CancelCustomer;
end;

end.
 