unit PartsFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBNAVSTATFRM, Menus, ImgList, ComCtrls, ToolWin, Grids, DBGrids, Db,
  StdCtrls, Mask, DBCtrls, DBModeFrm;

type
  TPartsForm = class(TDBNavStatForm)
    lblPartNo: TLabel;
    dbePartNo: TDBEdit;
    dsParts: TDataSource;
    lblDescription: TLabel;
    dbeDescription: TDBEdit;
    lblQuantity: TLabel;
    dbeQuantity: TDBEdit;
    lblListPrice: TLabel;
    dbeListPrice: TDBEdit;
    lblRetailPrice: TLabel;
    dbeRetailPrice: TDBEdit;
    lblDealerPrice: TLabel;
    dbeDealerPrice: TDBEdit;
    lblJobberPrice: TLabel;
    dbeJobberPrice: TDBEdit;
    dbgParts: TDBGrid;
    procedure sbAcceptClick(Sender: TObject);
    procedure sbCancelClick(Sender: TObject);
    procedure sbInsertClick(Sender: TObject);
    procedure sbEditClick(Sender: TObject);
    procedure sbDeleteClick(Sender: TObject);
    procedure sbFirstClick(Sender: TObject);
    procedure sbPrevClick(Sender: TObject);
    procedure sbNextClick(Sender: TObject);
    procedure sbLastClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sbFindClick(Sender: TObject);
    procedure sbBrowseClick(Sender: TObject);
  private
    procedure SetNavButtons;
  public
    function GetFormMenu: TMainMenu; override;
    function CanChange: Boolean; override;
  end;

var
  PartsForm: TPartsForm;

implementation

uses SalesDM;

{$R *.DFM}

procedure TPartsForm.SetNavButtons;
begin
  // Ensure that the navigational buttons are set according to the form's mode.
  sbFirst.Enabled := not DDGSalesDataModule.IsFirstPart;
  sbLast.Enabled  := not DDGSalesDataModule.IsLastPart;
  sbPrev.Enabled  := not DDGSalesDataModule.IsFirstPart;
  sbNext.Enabled  := not DDGSalesDataModule.IsLastPart;

  // synchronize the navigational menu items with the speedbuttons.
  mmiFirst.Enabled := sbFirst.Enabled;
  mmiLast.Enabled  := sbLast.Enabled;
  mmiPrevious.Enabled  := sbPrev.Enabled;
  mmiNext.Enabled  := sbNext.Enabled;
  
end;

procedure TPartsForm.sbAcceptClick(Sender: TObject);
begin
  // Accept add/edit changes to this part.
  inherited;
  DDGSalesDataModule.AcceptPart;
end;

procedure TPartsForm.sbCancelClick(Sender: TObject);
begin
  // Cancel add/Edit operation.
  inherited;
  DDGSalesDataModule.CancelPart;
end;

procedure TPartsForm.sbInsertClick(Sender: TObject);
begin
  // Insert a new part.
  inherited;
  DDGSalesDataModule.NewPart;
end;

procedure TPartsForm.sbEditClick(Sender: TObject);
begin
  // Edit the current part.
  inherited;
  DDGSalesDataModule.EditPart;
end;

procedure TPartsForm.sbDeleteClick(Sender: TObject);
begin
  // Delete the current part.
  inherited;
  DDGSalesDataModule.DeletePart;
end;

procedure TPartsForm.sbFirstClick(Sender: TObject);
begin
  // Go to the first record in the result set.
  inherited;
  DDGSalesDataModule.FirstPart;
  SetNavButtons;
end;

procedure TPartsForm.sbPrevClick(Sender: TObject);
begin
  // Go to the previous record in the result set.
  inherited;
  DDGSalesDataModule.PrevPart;
  SetNavButtons;
end;

procedure TPartsForm.sbNextClick(Sender: TObject);
begin
  // Go to the next record in the result set.
  inherited;
  DDGSalesDataModule.NextPart;
  SetNavButtons;
end;

procedure TPartsForm.sbLastClick(Sender: TObject);
begin
  // Go to the last record in the result set.
  inherited;
  DDGSalesDataModule.LastPart;
  SetNavButtons;
end;

procedure TPartsForm.FormShow(Sender: TObject);
begin
  // Initialize the speedbuttons and menu items accordingly.
  inherited;
  SetNavButtons;
end;

function TPartsForm.CanChange: Boolean;
begin
  // Allow the user to change forms, only if not adding or editing a record. 
  Result := FormMode = fmBrowse;
end;

function TPartsForm.GetFormMenu: TMainMenu;
begin
  // Return the main menu. This is used by the main form for menu merging of
  // child forms. 
  Result := mmFormMenu;
end;

procedure TPartsForm.sbFindClick(Sender: TObject);
begin
  // Search for a part by the part number.
  inherited;
  DDGSalesDataModule.SearchForPart;
end;

procedure TPartsForm.sbBrowseClick(Sender: TObject);
begin
  // Go into browse mode but only after canceling any changes made to the
  // current record. 
  inherited;
  if not (FormMode = fmBrowse) then
    DDGSalesDataModule.CancelPart;
end;

end.
