unit CustRDM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComServ, ComObj, VCLCom, StdVcl, BdeProv, DataBkr, DBClient, CustServ_TLB,
  Db, DBTables;

type

  TFilterType = (ftNone, ftCity, ftState);

  TCustomerRemoteDataModule = class(TRemoteDataModule, ICustomerRemoteDataModule)
    ssnCust: TSession;
    dbCust: TDatabase;
    qryCust: TQuery;
  private
    FFilterStr: String;
    FFilterType: TFilterType;
  public
    { Public declarations }
  protected
    function Get_qryCust: IProvider; safecall;
    procedure FilterByCity(const ACity: WideString; out Data: OleVariant);
      safecall;
    procedure FilterByState(const AStateStr: WideString; out Data: OleVariant);
      safecall;
    procedure NoFilter(out Data: OleVariant); safecall;
  end;

var
  CustomerRemoteDataModule: TCustomerRemoteDataModule;

implementation

{$R *.DFM}

function TCustomerRemoteDataModule.Get_qryCust: IProvider;
begin
  Result := qryCust.Provider;
end;

procedure TCustomerRemoteDataModule.FilterByCity(const ACity: WideString;
  out Data: OleVariant);
begin
  FFilterType  := ftCity;
  FFilterStr   := ACity;
  qryCust.Close;
  qryCust.SQL.Clear;
  qryCust.SQL.Add(Format('select * from CUSTOMER where CITY = "%s"', [ACity]));
  qryCust.Open;
  Data := qryCust.Provider.Data;
end;

procedure TCustomerRemoteDataModule.FilterByState(
  const AStateStr: WideString; out Data: OleVariant);
begin
  FFilterType  := ftState;
  FFilterStr   := AStateStr;
  qryCust.Close;
  qryCust.SQL.Clear;
  qryCust.SQL.Add(Format('select * from CUSTOMER where STATE = "%s"', [AStateStr]));
  qryCust.Open;
  Data := qryCust.Provider.Data;
end;

procedure TCustomerRemoteDataModule.NoFilter(out Data: OleVariant);
begin
  FFiltertype := ftNone;
  qryCust.Close;
  qryCust.SQL.Clear;
  qryCust.SQL.Add('select * from CUSTOMER');
  qryCust.Open;
  Data := qryCust.Provider.Data;
end;

initialization
  TComponentFactory.Create(ComServer, TCustomerRemoteDataModule,
    Class_CustomerRemoteDataModule, ciMultiInstance, tmSingle);
end.
