unit UserFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls;

type

  TUserForm = class(TForm)
    lblUserName: TLabel;
    dbeUserName: TDBEdit;
    lblFirstName: TLabel;
    dbeFirstName: TDBEdit;
    lblLastName: TLabel;
    dbeLastName: TDBEdit;
    btnOK: TButton;
    btnCancel: TButton;
    procedure btnOKClick(Sender: TObject);
  private
    FPostUser: TNotifyEvent;
  public
    { Public declarations }
  end;

function NewUserForm(APostUser: TNotifyEvent): Word;

implementation
uses dbTables;
{$R *.DFM}

function NewUserForm(APostUser: TNotifyEvent): Word;
var
  UserForm: TUserForm;
begin
  UserForm := TUserForm.Create(Application);
  try
    UserForm.FPostUser := APostUser;
    Result := UserForm.ShowModal;
  finally
    UserForm.Free;
  end;
end;

procedure TUserForm.btnOKClick(Sender: TObject);
begin
  if dbeUserName.Text = EmptyStr then begin
    MessageDlg('A user name is required.', mtWarning, [mbOK], 0);
    dbeUserName.SetFocus;
    ModalResult := mrNone;
  end
  else begin
    try
      FPostUser(self);
    except
      on EDBEngineError do
      begin
        MessageDlg('User name already exists.', mtWarning, [mbOK], 0);
        dbeUserName.SetFocus;
        ModalResult := mrNone;
      end;
    end;
  end;
end;

end.
