{
Copyright  1998 by Delphi 4 Developer's Guide - Xavier Pacheco and Steve Teixeira
}
unit ABExpt;

interface

uses Windows, ExptIntf, ToolIntf, Classes;

type
  TAppBarExpert = class(TIExpert)
  private
    function GetFormStream(const AName: string): TMemoryStream;
    function GetSourceStream(const AUnitName, AFormName: string): TMemoryStream;
  public
    function GetName: string; override; stdcall;
    function GetAuthor: string; override; stdcall;
    function GetComment: string; override; stdcall;
    function GetPage: string; override; stdcall;
    function GetGlyph: HICON; override; stdcall;
    function GetStyle: TExpertStyle; override; stdcall;
    function GetState: TExpertState; override; stdcall;
    function GetIDString: string; override; stdcall;
    procedure Execute; override; stdcall;
  end;

implementation

uses Forms, AppBars, SysUtils, IStreams, Proxies, Dialogs;

// The following RES file contains the unformatted source code
{$R CodeGen.res}

{ TAppBarExpert }

function TAppBarExpert.GetGlyph: HICON;
begin
  Result := 0; {!!}
end;

function TAppBarExpert.GetIDString: string;
begin
  Result := 'DDG.AppBarExpert';
end;

function TAppBarExpert.GetName: string;
begin
  Result := 'DDG AppBar Expert';
end;

function TAppBarExpert.GetPage: string;
begin
  Result := 'DDG';
end;

function TAppBarExpert.GetState: TExpertState;
begin
  Result := [esEnabled];
end;

function TAppBarExpert.GetStyle: TExpertStyle;
begin
  Result := esForm;
end;

function TAppBarExpert.GetAuthor: string;
begin
  Result := 'Delphi 4 Developer''s Guide';
end;

function TAppBarExpert.GetComment: string;
begin
  Result := 'Creates a new AppBar form.'
end;

function TAppBarExpert.GetFormStream(const AName: string): TMemoryStream;
var
  AB: TAppBar;
begin
  AB := TAppBar.CreateNew(nil);
  try
    Proxies.CreateSubClass(AB, 'T' + AName, TAppBar);
    AB.Name := AName;
    Result := TMemoryStream.Create;
    Result.WriteComponentRes(AName, AB);
    Result.Position := 0;
  finally
    AB.Free;
  end;
end;

function TAppBarExpert.GetSourceStream(const AUnitName, AFormName: string): TMemoryStream;
var
  Text: string;
  ResInstance: THandle;
begin
  ResInstance := FindResourceHInstance(HInstance);
  Text := PChar(LockResource(LoadResource(ResInstance,
    FindResource(ResInstance, 'CODEGEN', RT_RCDATA))));
  Text := Format(Text, [AUnitName, AFormName]);
  Result := TMemoryStream.Create;
  Result.Write(Pointer(Text)^, Length(Text));
  Result.Position := 0;
end;

procedure TAppBarExpert.Execute;
var
  UnitName, FileName, FormName: string;
  SourceStream, FormStream: TIMemoryStream;
begin
  if (ToolServices <> nil) and ToolServices.GetNewModuleName(UnitName, FileName) then
  begin
    UnitName := LowerCase(UnitName);
    UnitName[1] := UpCase(UnitName[1]);
    FormName := 'AppBar' + Copy(UnitName, 5, Length(UnitName));
    FormStream := TIMemoryStream.Create(GetFormStream(FormName), soOwned);
    SourceStream := TIMemoryStream.Create(GetSourceStream(UnitName, FormName),
      soOwned);
    ToolServices.CreateModule(FileName, SourceStream, FormStream,
      [cmAddToProject, cmShowSource, cmShowForm, cmUnNamed, cmMarkModified]);
  end;
end;

end.
