{
Copyright  1998 by Delphi 4 Developer's Guide - Xavier Pacheco and Steve Teixeira
}
unit ABMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Menus, AppBars;

type
  TEditAppBar = class(TAppBar)
    PopupMenu1: TPopupMenu;
    Top1: TMenuItem;
    Bottom1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    OpenDialog1: TOpenDialog;
    N1: TMenuItem;
    Exit1: TMenuItem;
    procedure Top1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FLastChecked: TMenuItem;
     procedure MoveButtons;
  end;

var
  EditAppBar: TEditAppBar;

implementation

{$R *.DFM}

uses Main;

procedure TEditAppBar.Top1Click(Sender: TObject);
begin
  FLastChecked.Checked := False;
  (Sender as TMenuItem).Checked := True;
  case TMenuItem(Sender).Caption[2] of
    'T': Edge := abeTop;
    'B': Edge := abeBottom;
    'L': Edge := abeLeft;
    'R': Edge := abeRight;
  end;
  FLastChecked := TMenuItem(Sender);
end;

procedure TEditAppBar.MoveButtons;
// This method looks complicated, but it really just arranges the buttons
// properly depending on what side the AppBar is docked.
var
  DeltaCenter, NewPos: Integer;
begin
  if Edge in [abeTop, abeBottom] then
  begin
    DeltaCenter := (ClientHeight - SpeedButton1.Height) div 2;
    SpeedButton1.SetBounds(10, DeltaCenter, SpeedButton1.Width, SpeedButton1.Height);
    NewPos := SpeedButton1.Width + 20;
    SpeedButton2.SetBounds(NewPos, DeltaCenter, SpeedButton1.Width, SpeedButton1.Height);
    NewPos := NewPos + SpeedButton1.Width + 10;
    SpeedButton3.SetBounds(NewPos, DeltaCenter, SpeedButton1.Width, SpeedButton1.Height);
    NewPos := NewPos + SpeedButton1.Width + 10;
    SpeedButton4.SetBounds(NewPos, DeltaCenter, SpeedButton1.Width, SpeedButton1.Height);
    NewPos := NewPos + SpeedButton1.Width + 10;
    SpeedButton5.SetBounds(NewPos, DeltaCenter, SpeedButton1.Width, SpeedButton1.Height);
  end
  else
  begin
    DeltaCenter := (ClientWidth - SpeedButton1.Width) div 2;
    SpeedButton1.SetBounds(DeltaCenter, 10, SpeedButton1.Width, SpeedButton1.Height);
    NewPos := SpeedButton1.Height + 20;
    SpeedButton2.SetBounds(DeltaCenter, NewPos, SpeedButton1.Width, SpeedButton1.Height);
    NewPos := NewPos + SpeedButton1.Height + 10;
    SpeedButton3.SetBounds(DeltaCenter, NewPos, SpeedButton1.Width, SpeedButton1.Height);
    NewPos := NewPos + SpeedButton1.Height + 10;
    SpeedButton4.SetBounds(DeltaCenter, NewPos, SpeedButton1.Width, SpeedButton1.Height);
    NewPos := NewPos + SpeedButton1.Height + 10;
    SpeedButton5.SetBounds(DeltaCenter, NewPos, SpeedButton1.Width, SpeedButton1.Height);
  end;
end;

procedure TEditAppBar.SpeedButton1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    MainForm.FileName := OpenDialog1.FileName;
end;

procedure TEditAppBar.SpeedButton2Click(Sender: TObject);
begin
  MainForm.Memo1.Lines.SaveToFile(MainForm.FileName);
end;

procedure TEditAppBar.SpeedButton3Click(Sender: TObject);
begin
  MainForm.Memo1.CutToClipboard;
end;

procedure TEditAppBar.SpeedButton4Click(Sender: TObject);
begin
  MainForm.Memo1.CopyToClipboard;
end;

procedure TEditAppBar.SpeedButton5Click(Sender: TObject);
begin
  MainForm.Memo1.PasteFromClipboard;
end;

procedure TEditAppBar.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TEditAppBar.FormCreate(Sender: TObject);
begin
  FLastChecked := Top1;
end;

end.
 