{
Copyright  1998 by Delphi 4 Developer's Guide - Xavier Pacheco and Steve Teixeira
}

unit WorthLess;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type

  TSomeObject = class(TPersistent)
  private
    FProp1: Integer;
    FProp2: String;
  public
    procedure Assign(Source: TPersistent); override;
  published
    property Prop1: Integer read FProp1 write FProp1;
    property Prop2: String read FProp2 write FProp2;
  end;


  TEnumProp = (epZero, epOne, epTwo, epThree);

  TSetPropOption = (poOne, poTwo, poThree, poFour, poFive);
  TSetPropOptions = set of TSetPropOption;

  TddgWorthless = class(TCustomControl)
  private
    // Internal Data Storage
    FIntegerProp: Integer;
    FStringProp: String;
    FCharProp: Char;
    // Enumerated data types
    FEnumProp: TEnumProp;
    FBooleanProp: Boolean;
    // Set Date Storage
    FOptions: TSetPropOptions;
    // Object field
    FSomeObject: TSomeObject;
  protected
    procedure SetSomeObject(Value: TSomeObject);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    // Simple property types
    property IntegerProp: Integer read FIntegerProp write FIntegerProp default 100;
    property StringProp: String read FStringProp write FStringProp;
    property CharProp: Char read FCharProp write FCharProp;
    // Enumerated Properties
    property EnumProp: TEnumProp read FEnumProp write FEnumProp;
    property BooleanProp: Boolean read FBooleanProp write FBooleanProp;
    // Set Property
    property Options: TSetPropOptions read FOptions write FOptions;
    // Object Property
    property SomeObject: TSomeObject read FSomeObject write SetSomeObject;
end;

implementation

procedure TSomeObject.Assign(Source: TPersistent);
begin
  if Source is TSomeObject then
  begin
    FProp1 := TSomeObject(Source).Prop1;
    FProp2 := TSomeObject(Source).Prop2;
    inherited Assign(Source);
  end;
end;

constructor TddgWorthless.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FSomeObject := TSomeObject.Create;
  // Set the default value
  IntegerProp := 100;
end;

destructor TddgWorthless.Destroy;
begin
  FSomeObject.Free;
  inherited Destroy;
end;

procedure TddgWorthless.SetSomeObject(Value: TSomeObject);
begin
  if Assigned(Value) then
    FSomeObject.Assign(Value);
end;

end.
